## luametatex 2.11.01+really2.10.08+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(luametatex VERSION 2.10 LANGUAGES C)

set(CMAKE_C_STANDARD 11)
# set(CMAKE_CXX_STANDARD 17)

# https://sourceforge.net/p/predef/wiki/OperatingSystems/
# https://sourceforge.net/p/predef/wiki/Architectures/

include(GNUInstallDirs)

# Optionals (maybe have a LMT_*_TOO for each of them). We might start out with only a very few
# optionals at some time, but for now we enable them (there is not not much code involved). The 
# idea behind thes eoptionals is that we have very simple (!) interfaces, delegating as much as 
# possible to Lua. We will *not* add interfaces with many bindings because that will introduce
# dependencies (and looking at e.g. LuaTeX build updates shows that clearly: a no-go). 

set(LMT_KPSE_TOO 1) # In case we want to manage MKII scripts (etc) with mtxrun.
set(LMT_HB_TOO   1) # Maybe handy for Idris' font development (old converted ffi stuff)

# When set, because we're sparse we also strip the binary. Because we only gain some 1-2% on
# runtime, enabling it makes not much sense:

# set(LMT_OPTIMIZE 1)

if (MSVC)

    if (CMAKE_C_COMPILER_ID STREQUAL "Clang")

        add_compile_options(
            -Wall
            -O2

            -Wcast-align
            -Wcast-qual

            -Wno-unknown-pragmas
            -fno-strict-aliasing

            -Wno-pedantic
            -Wno-deprecated-declarations
            -Wno-missing-noreturn
            -Wno-shadow
        )

        add_definitions(-D_CRT_SECURE_NO_WARNINGS)

        add_definitions(-DLMT_COMPILER_USED="clang")

    else()

        add_compile_options(
            /Wall

            /wd4127 # constant conditional expression
            /wd4131 # old style declarator
            /wd4152 # function pointer cast
            /wd4201 # nonstandard extension used: nameless struct/union
            /wd4244 # assignment in conditional expression
            /wd4456 # local vars with same name as outer variable
            /wd4457 # local vars with same function parameter
            /wd4464 # relative include path
            /wd4668 # missing defines
            /wd4702 # unreachable code
            /wd4710 # inlining
            /wd4711 # inlining
            /wd4774 # sprint argument 2 warning
            /wd4777 # format argument 2 warning
            /wd4820 # local vars with same name as outer variable
            /wd4996 # strdup etc warnings
            /wd5045 # spectre

          # /GL     # whole program link optimization
          # /Gw     # whole program data optimization (a little smaller bin)

          # /Ob3    # more agressive inline, much larger bin, no gain

            /wd4061 # enumerator * in switch * is not explicitly handles (mp)
            /wd4701 # potentially unitialized local variable (lua)
            /wd4255 # no function prototype given

            /wd5105 # macro expansion producing 'defined' has undefined behavior

            /wd4548 # expression before comma has no effect; expected expression with side-effect

            # indeed a bit faster but also a much larger binary:

            # /fp:fast

            # okay for amd processors too but no difference in size so probably no gain:

          # /favor:INTEL64
          # /fsanitize:address
          # /std:c17

        )

        # We always optimize ... symbols are not in the binary anyway so there is no advantage
        # (like when accessing Lua api functions). We could have an additional luametatex-lua.dll
        # but that also creates a dependency (possible conflict).

      # if (DEFINED LMT_OPTIMIZE)
            add_compile_options(
                /GL # whole program link optimization
                /Gw # whole program data optimization (a little smaller bin)
            )
      # endif()

        add_definitions(-DLMT_COMPILER_USED="msvc")

    endif()

 else()

    if (CMAKE_C_COMPILER_ID STREQUAL "Clang")

        # why not -03

        add_compile_options(
            -O2
        )

        add_definitions(-DLMT_COMPILER_USED="clang")

    else()

        add_compile_options(
            -O3
          # -g0
          # -mtune=nocona # fails on arm so more testing needed
        )

        add_definitions(-DLMT_COMPILER_USED="gcc")

      # add_compile_options(-pg)
      # add_link_options(-pg)

    endif()

    add_compile_options(
        -Wall

        -Wcast-align
        -Wcast-qual

        -Wno-unknown-pragmas
        -Wno-unused-result
        -fno-strict-aliasing
    )

    # for c17
    #
    # add_definitions(-D__STDC_WANT_LIB_EXT2__=1)

    if (DEFINED LMT_OPTIMIZE)
        if (NOT (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
            set(CMAKE_EXE_LINKER_FLAGS "-s")
        endif()
    endif()

endif()

if (CMAKE_C_COMPILER_ID STREQUAL "Clang")

    add_compile_options(
        -Wno-unknown-warning-option
        -Wno-nonportable-include-path
        -Wno-nonportable-system-include-path
        -Wno-newline-eof
        -Wno-extra-semi-stmt
        -Wno-sign-conversion
        -Wno-unused-macros
        -Wno-reserved-id-macro
        -Wno-comma
        -Wno-switch-enum
        -Wno-shadow
        -Wno-missing-noreturn
        -Wno-implicit-fallthrough
      # -Wno-format
        -Wno-reserved-identifier
        -Wno-date-time
        -Wno-format-nonliteral
        -Wno-float-equal
    )

endif()

# Not that tested (converted ffi originals):

if ((DEFINED LMT_KPSE_TOO))
    add_definitions(-DLMT_KPSE_TOO=1)
endif()
if ((DEFINED LMT_HB_TOO))
    add_definitions(-DLMT_HB_TOO=1)
endif()

# This needs cmake >= 3.9 and produces a 60K smaller mingw binary but it take quite a bit of
# runtime to get there so it should become an option (apart from testing on all builders).

if (DEFINED LMT_OPTIMIZE)

    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported OUTPUT ipo_message)

    if (ipo_supported)
        #
        # We only have one program so we do it global (can become an -- option)
        #
        # set_property(TARGET luametatex PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
        #
        # mingw64: 2865664, nocona: 2819584, lto: 2835968 (around 1% gain on manual)
        #
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
        #
    else()
        # No message needed, just accept the fact.
    endif()

endif()

# Mimalloc is still under development, so we only support it on a few platforms. By the time it is
# stable we can probably remove some of the following tests. A bit of a hack:
#
# When the old osx version is dropped and armhf is upgraded we can enable unix except solaris which
# fails. So, only osx 10.6 and rpi 32 fail. But we will probably drop 32 bit in the future anyway.

# CMAKE_HOST_SYSTEM_PROCESSOR arm64 x86_64

if (CMAKE_HOST_SOLARIS)
    # fails
elseif (MSVC)
    set(luametatex_use_mimalloc 1)
elseif (CMAKE_HOST_APPLE AND NOT (${CMAKE_C_COMPILER} MATCHES "arm"))
    # fails on the osx intel
elseif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "armv7l")
    # fails on the rpi 32 bit
else()
    set(luametatex_use_mimalloc 1)
endif()

include_directories(${CMAKE_ROOT}/source)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/source)

if ((DEFINED luametatex_use_mimalloc))
    add_definitions(-DLUAMETATEX_USE_MIMALLOC=1)
  # add_definitions(-DMIMALLOC_RESET_DELAY=250)
  # set(luametatex_use_mimalloc 1)
    include(cmake/mimalloc.cmake)
endif()

include(cmake/tex.cmake)
include(cmake/lua.cmake)
include(cmake/mp.cmake)

include(cmake/luarest.cmake)
include(cmake/luasocket.cmake)
include(cmake/luaoptional.cmake)

include(cmake/pplib.cmake)
include(cmake/miniz.cmake)
include(cmake/softposit.cmake)

include(cmake/luametatex.cmake)

## luametatex 2.10.08+ds

=== debian/changelog ===
luametatex (2.10.08+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1034501)

 -- Hilmar Preusse <hille42@web.de>  Tue, 18 Jul 2023 00:02:20 +0200

=== debian/control ===
Source: luametatex
Section: tex
Priority: optional
Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
Uploaders: Hilmar Preusse <hille42@web.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libmimalloc-dev
Standards-Version: 4.6.2
Homepage: https://github.com/contextgarden/luametatex
Vcs-Browser: https://github.com/debian-tex/luametatex
Vcs-Git: https://github.com/debian-tex/luametatex.git

Package: luametatex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Next generation ConTeXt processing engine
 The LuaMetaTeX program is a light weight variant of LuaTeX. This
 program finds its origin in parts of TeX (the original program, eTeX
 (some extensions), pdfTeX (more extensions) Aleph (based on Omega,
 directions) and of course LuaTeX (lots of things).
 .
 This is a follow up on the LuaTeX project. The source is considered
 part of the ConTeXt distribution and managed by the ConTeXt development
 team and the ConTeXt user group. That way it can be guaranteed that the
 engine and this TeX macro package work together as expected. The idea
 is that users can easily compile the source themselves and that way
 have a guaranteed long term (minimal) TeX based installation. Because
 the management scripts are in Lua, only one binary is needed to serve
 the ConTeXt distribution.
 .
 In the source code it was tried to stay close to the ancestors, LuaTeX,
 pdfTeX, eTeX and TeX, but in the meantime due to additions there is
 quite some diverge. There are new primitives and submechanisms, there
 is more control over the inner workings, font handling is mostly
 delegated to Lua and there is no built-in backend. The code base is
 all-inclusive and has no (nor will have) dependencies on external
 libraries. Performance and memory consumption have been optimized and
 the additions (compared to LuaTeX) don’t have a negative impact.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## luametatex 2.11.01+ds

=== debian/changelog ===
luametatex (2.11.01+ds-2) unstable; urgency=medium

  * armel needs linking with libatomic too.

 -- Hilmar Preusse <hille42@web.de>  Tue, 20 Feb 2024 23:26:24 +0100

luametatex (2.11.01+ds-1) unstable; urgency=medium

  * New upstream release, refresh patches.
    - Should fix build failure on HURD.
    - Contains a local copy of potrace -> extend d/copyright.
    - Redo d/patches/no_strip.diff, stripping is configured in a
      different file.
  * Update d/gbp.conf.
  * Link luametatex with libatomic on m68k, powerpc and sh4. Should fix
    FTBFS on these arches.

 -- Hilmar Preusse <hille42@web.de>  Tue, 20 Feb 2024 08:23:29 +0000

## luametatex 2.11.01+really2.10.08+ds

=== debian/changelog ===
luametatex (2.11.01+really2.10.08+ds-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:53:14 +1100

luametatex (2.11.01+really2.10.08+ds-1) unstable; urgency=medium

  * Downgrade to 2.10.08 (Closes: #1064402).

 -- Hilmar Preusse <hille42@web.de>  Wed, 06 Mar 2024 23:18:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: luametatex
 Section: tex
 Priority: optional
-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
 Uploaders: Hilmar Preusse <hille42@web.de>
 Rules-Requires-Root: no
 Build-Depends:

## luametatex 2.11.02%2Breally2.11.01%2Bds

=== debian/changelog ===
luametatex (2.11.02+really2.11.01+ds-1) unstable; urgency=medium

  * The version/snapshot of ConTeXt in Debian does to fit to ltmx
    2.11.02, downgrade to 2.11.01 again (Closes: #1072682).
  * Disable patches for mimalloc.

 -- Hilmar Preusse <hille42@web.de>  Sat, 15 Jun 2024 23:25:01 +0200

luametatex (2.11.02+ds-4) unstable; urgency=medium

  * Upload to unstable.

 -- Hilmar Preusse <hille42@web.de>  Wed, 05 Jun 2024 14:13:07 +0200

luametatex (2.11.02+ds-3) experimental; urgency=medium

  * Link dynamically with mimalloc.
  * Patch handling:
    - adding, fixing DEP-3 headers
    - removing obsolete patch

 -- Hilmar Preusse <hille42@web.de>  Fri, 24 May 2024 22:35:07 +0200

luametatex (2.11.02+ds-2) experimental; urgency=medium

  * Add patches from upstream to fix build failures on arches, where
    ‘__builtin_thread_pointer’ is not supported.
    https://github.com/microsoft/mimalloc/issues/883 .

 -- Hilmar Preusse <hille42@web.de>  Thu, 16 May 2024 08:40:41 +0200

luametatex (2.11.02+ds-1) experimental; urgency=medium

  * New upstream version.
    See https://github.com/contextgarden/luametatex/issues/12
  * Add Breaks statement for old context.

 -- Hilmar Preusse <hille42@web.de>  Wed, 15 May 2024 23:53:44 +0200

luametatex (2.11.01+really2.11.01+ds-1) experimental; urgency=medium

  * Reupload version 2.11.01 for TL 2024.

 -- Hilmar Preusse <hille42@web.de>  Sun, 21 Apr 2024 16:35:11 +0200

## luametatex 2.11.02+really2.11.01+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 project(luametatex VERSION 2.10 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
-# set(CMAKE_CXX_STANDARD 17)
+# set(CMAKE_C_STANDARD 17) # needs 3.21
 
 # https://sourceforge.net/p/predef/wiki/OperatingSystems/
 # https://sourceforge.net/p/predef/wiki/Architectures/
@@ -12,7 +12,7 @@
 
 # Optionals (maybe have a LMT_*_TOO for each of them). We might start out with only a very few
 # optionals at some time, but for now we enable them (there is not not much code involved). The 
-# idea behind thes eoptionals is that we have very simple (!) interfaces, delegating as much as 
+# idea behind these optionals is that we have very simple (!) interfaces, delegating as much as 
 # possible to Lua. We will *not* add interfaces with many bindings because that will introduce
 # dependencies (and looking at e.g. LuaTeX build updates shows that clearly: a no-go). 
 
@@ -24,9 +24,15 @@
 
 # set(LMT_OPTIMIZE 1)
 
+# This makes the binary some 135K smaller so it might become the default at some point which is 
+# nice (the smaller as runner the better). After all, we don't load external (Lua) libraries 
+# anyway. 
+
+set(LMT_STRIP 1)
+
 if (MSVC)
 
-    if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    if (CMAKE_C_COMPILER_ID MATCHES "Clang")
 
         add_compile_options(
             -Wall
@@ -98,7 +104,8 @@
 
         # We always optimize ... symbols are not in the binary anyway so there is no advantage
         # (like when accessing Lua api functions). We could have an additional luametatex-lua.dll
-        # but that also creates a dependency (possible conflict).
+        # but that also creates a dependency (possible conflict). So just don't expect using 
+        # Lua libraries in luametatex. 
 
       # if (DEFINED LMT_OPTIMIZE)
             add_compile_options(
@@ -113,7 +120,7 @@
 
  else()
 
-    if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    if (CMAKE_C_COMPILER_ID MATCHES "Clang")
 
         # why not -03
 
@@ -153,7 +160,7 @@
     #
     # add_definitions(-D__STDC_WANT_LIB_EXT2__=1)
 
-    if (DEFINED LMT_OPTIMIZE)
+    if ((DEFINED LMT_OPTIMIZE) OR (DEFINED LMT_STRIP))
         if (NOT (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
             set(CMAKE_EXE_LINKER_FLAGS "-s")
         endif()
@@ -161,7 +168,7 @@
 
 endif()
 
-if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
+if (CMAKE_C_COMPILER_ID MATCHES "Clang")
 
     add_compile_options(
         -Wno-unknown-warning-option
@@ -182,6 +189,10 @@
         -Wno-date-time
         -Wno-format-nonliteral
         -Wno-float-equal
+      # too noisy, we just look at what gcc reports 
+        -Wno-unsafe-buffer-usage
+        -Wno-macro-redefined
+        -Wno-undef
     )
 
 endif()
@@ -260,5 +271,6 @@
 include(cmake/pplib.cmake)
 include(cmake/miniz.cmake)
 include(cmake/softposit.cmake)
+include(cmake/potrace.cmake)
 
 include(cmake/luametatex.cmake)

=== source/luacore/lua55/src/Makefile ===
# Developer's makefile for building Lua
# see luaconf.h for further customization

# == CHANGE THE SETTINGS BELOW TO SUIT YOUR ENVIRONMENT =======================

# Warnings valid for both C and C++
CWARNSCPP= \
	-Wfatal-errors \
	-Wextra \
	-Wshadow \
	-Wundef \
	-Wwrite-strings \
	-Wredundant-decls \
	-Wdisabled-optimization \
	-Wdouble-promotion \
	-Wmissing-declarations \
        # the next warnings might be useful sometimes,
	# but usually they generate too much noise
	# -Werror \
	# -pedantic   # warns if we use jump tables \
	# -Wconversion  \
	# -Wsign-conversion \
	# -Wstrict-overflow=2 \
	# -Wformat=2 \
	# -Wcast-qual \


# Warnings for gcc, not valid for clang
CWARNGCC= \
	-Wlogical-op \
	-Wno-aggressive-loop-optimizations \


# The next warnings are neither valid nor needed for C++
CWARNSC= -Wdeclaration-after-statement \
	-Wmissing-prototypes \
	-Wnested-externs \
	-Wstrict-prototypes \
	-Wc++-compat \
	-Wold-style-definition \


CWARNS= $(CWARNSCPP) $(CWARNSC) $(CWARNGCC)

# Some useful compiler options for internal tests:
# -DLUAI_ASSERT turns on all assertions inside Lua.
# -DHARDSTACKTESTS forces a reallocation of the stack at every point where
# the stack can be reallocated.
# -DHARDMEMTESTS forces a full collection at all points where the collector
# can run.
# -DEMERGENCYGCTESTS forces an emergency collection at every single allocation.
# -DEXTERNMEMCHECK removes internal consistency checking of blocks being
# deallocated (useful when an external tool like valgrind does the check).
# -DMAXINDEXRK=k limits range of constants in RK instruction operands.
# -DLUA_COMPAT_5_3

# -pg -malign-double
# -DLUA_USE_CTYPE -DLUA_USE_APICHECK

# The following options help detect "undefined behavior"s that seldom
# create problems; some are only available in newer gcc versions. To
# use some of them, we also have to define an environment variable
# ASAN_OPTIONS="detect_invalid_pointer_pairs=2".
# -fsanitize=undefined
# -fsanitize=pointer-subtract -fsanitize=address -fsanitize=pointer-compare
# TESTS= -DLUA_USER_H='"ltests.h"' -O0 -g


LOCAL = $(TESTS) $(CWARNS)


# enable Linux goodies
MYCFLAGS= $(LOCAL) -std=c99 -DLUA_USE_LINUX -DLUA_USE_READLINE
MYLDFLAGS= $(LOCAL) -Wl,-E
MYLIBS= -ldl -lreadline


CC= gcc
CFLAGS= -Wall -O2 $(MYCFLAGS) -fno-stack-protector -fno-common -march=native
AR= ar rc
RANLIB= ranlib
RM= rm -f



# == END OF USER SETTINGS. NO NEED TO CHANGE ANYTHING BELOW THIS LINE =========


LIBS = -lm

CORE_T=	liblua.a
CORE_O=	lapi.o lcode.o lctype.o ldebug.o ldo.o ldump.o lfunc.o lgc.o llex.o \
	lmem.o lobject.o lopcodes.o lparser.o lstate.o lstring.o ltable.o \
	ltm.o lundump.o lvm.o lzio.o ltests.o
AUX_O=	lauxlib.o
LIB_O=	lbaselib.o ldblib.o liolib.o lmathlib.o loslib.o ltablib.o lstrlib.o \
	lutf8lib.o loadlib.o lcorolib.o linit.o

LUA_T=	lua
LUA_O=	lua.o


ALL_T= $(CORE_T) $(LUA_T)
ALL_O= $(CORE_O) $(LUA_O) $(AUX_O) $(LIB_O)
ALL_A= $(CORE_T)

all:	$(ALL_T)
	touch all

o:	$(ALL_O)

a:	$(ALL_A)

$(CORE_T): $(CORE_O) $(AUX_O) $(LIB_O)
	$(AR) $@ $?
	$(RANLIB) $@

$(LUA_T): $(LUA_O) $(CORE_T)
	$(CC) -o $@ $(MYLDFLAGS) $(LUA_O) $(CORE_T) $(LIBS) $(MYLIBS) $(DL)


clean:
	$(RM) $(ALL_T) $(ALL_O)

depend:
	@$(CC) $(CFLAGS) -MM *.c

echo:
	@echo "CC = $(CC)"
	@echo "CFLAGS = $(CFLAGS)"
	@echo "AR = $(AR)"
	@echo "RANLIB = $(RANLIB)"
	@echo "RM = $(RM)"
	@echo "MYCFLAGS = $(MYCFLAGS)"
	@echo "MYLDFLAGS = $(MYLDFLAGS)"
	@echo "MYLIBS = $(MYLIBS)"
	@echo "DL = $(DL)"

$(ALL_O): makefile ltests.h

# DO NOT EDIT
# automatically made with 'gcc -MM l*.c'

lapi.o: lapi.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lstring.h \
 ltable.h lundump.h lvm.h
lauxlib.o: lauxlib.c lprefix.h lua.h luaconf.h lauxlib.h
lbaselib.o: lbaselib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lcode.o: lcode.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lgc.h lstring.h ltable.h lvm.h
lcorolib.o: lcorolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lctype.o: lctype.c lprefix.h lctype.h lua.h luaconf.h llimits.h
ldblib.o: ldblib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ldebug.o: ldebug.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h lcode.h llex.h lopcodes.h lparser.h \
 ldebug.h ldo.h lfunc.h lstring.h lgc.h ltable.h lvm.h
ldo.o: ldo.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lopcodes.h \
 lparser.h lstring.h ltable.h lundump.h lvm.h
ldump.o: ldump.c lprefix.h lua.h luaconf.h lobject.h llimits.h lstate.h \
 ltm.h lzio.h lmem.h lundump.h
lfunc.o: lfunc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h
lgc.o: lgc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lstring.h ltable.h
linit.o: linit.c lprefix.h lua.h luaconf.h lualib.h lauxlib.h
liolib.o: liolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
llex.o: llex.c lprefix.h lua.h luaconf.h lctype.h llimits.h ldebug.h \
 lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lgc.h llex.h lparser.h \
 lstring.h ltable.h
lmathlib.o: lmathlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lmem.o: lmem.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h
loadlib.o: loadlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lobject.o: lobject.c lprefix.h lua.h luaconf.h lctype.h llimits.h \
 ldebug.h lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h \
 lvm.h
lopcodes.o: lopcodes.c lprefix.h lopcodes.h llimits.h lua.h luaconf.h
loslib.o: loslib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lparser.o: lparser.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lfunc.h lstring.h lgc.h ltable.h
lstate.o: lstate.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h llex.h \
 lstring.h ltable.h
lstring.o: lstring.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h
lstrlib.o: lstrlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltable.o: ltable.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
ltablib.o: ltablib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltests.o: ltests.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h lauxlib.h lcode.h llex.h lopcodes.h \
 lparser.h lctype.h ldebug.h ldo.h lfunc.h lopnames.h lstring.h lgc.h \
 ltable.h lualib.h
ltm.o: ltm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
lua.o: lua.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lundump.o: lundump.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lstring.h lgc.h \
 lundump.h
lutf8lib.o: lutf8lib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lvm.o: lvm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lopcodes.h lstring.h \
 ltable.h lvm.h ljumptab.h
lzio.o: lzio.c lprefix.h lua.h luaconf.h llimits.h lmem.h lstate.h \
 lobject.h ltm.h lzio.h

# (end of Makefile)

=== source/luaoptional/cmake/mujs/CMakeLists.txt ===
# This file is made by Mojca and Hans and is subjected to changes
# as we proceed with luametatex and the contextgarden compile farm.

cmake_minimum_required(VERSION 3.7)

# Lucky us: only normal C is used:

project (mujs
	VERSION 1.0.6
	DESCRIPTION "MuJS embeddable Javascript interpreter"
	LANGUAGES C)

# The jsrepr.c is not needed and depends on utf.c as well has some function
# pointer cast issue (accessing unknown name field).

set (mujs_sources
	jsarray.c
	jsboolean.c
	jsbuiltin.c
	jscompile.c
	jsdate.c
	jsdtoa.c
	jsdump.c
	jserror.c
	jsfunction.c
	jsgc.c
	jsintern.c
	jslex.c
	jsmath.c
	jsnumber.c
	jsobject.c
	json.c
	jsparse.c
	jsproperty.c
	jsregexp.c
#	jsrepr.c
	jsrun.c
	jsstate.c
	jsstring.c
	jsvalue.c
	regexp.c
	utf.c
	utftype.c
)

set (mujs_headers
	jsbuiltin.h
	jscompile.h
	jsi.h
	jslex.h
	jsparse.h
	jsrun.h
	jsvalue.h
	mujs.h
	regexp.h
	utf.h
)

# We need this in order for msvc to export the symbols (which is default on
# gcc). Otherwise we need this dllexport stuff.

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# The previous one has to come before the next one!

if (MSVC)

	add_library(mujs SHARED ${mujs_headers} ${mujs_sources} )

else()

	# Is this hack still needed or does the above work ok.?

	add_library(mujs SHARED ${mujs_headers} one.c)

endif()

# As per make file.

set_property(TARGET mujs PROPERTY C_STANDARD 99)

# We want consistent and predictable names:

set_target_properties(mujs PROPERTIES OUTPUT_NAME "libmujs")

# Some options based on what's in upstream's make file.

if (NOT MSVC)

	target_compile_options(mujs
		PRIVATE
			-pedantic
			-Wall
			-Wextra
			-Wno-unused-parameter
		)

	if (CMAKE_C_COMPILER_ID STREQUAL "Clang")

		target_compile_options(mujs
			PRIVATE
				-Wunreachable-code
		)

	endif()

endif()

=== debian/changelog ===
luametatex (2.11.02+really2.11.01+ds-1build1) plucky; urgency=medium

  * No-change rebuild for libmimalloc3.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 27 Jan 2025 16:45:30 +0000

## luametatex 2.11.07+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,13 @@
-cmake_minimum_required(VERSION 3.9)
-
-project(luametatex VERSION 2.10 LANGUAGES C)
+# We use CMake but I bet we can also provide a simple make file for linux just because 
+# when I look what gets compiled into CMake we need very little of that (and it 
+# has a lot of dependencies - ssh related, compression, security, xml, etc), but maybe 
+# there is a lightweight version of CMake. 
+
+cmake_minimum_required(VERSION 3.9..3.28)
+
+project(luametatex VERSION 2.11 LANGUAGES C)
+
+# I need to check with Mojca of the compile farm can handle this. 
 
 set(CMAKE_C_STANDARD 11)
 # set(CMAKE_C_STANDARD 17) # needs 3.21
@@ -19,8 +26,8 @@
 set(LMT_KPSE_TOO 1) # In case we want to manage MKII scripts (etc) with mtxrun.
 set(LMT_HB_TOO   1) # Maybe handy for Idris' font development (old converted ffi stuff)
 
-# When set, because we're sparse we also strip the binary. Because we only gain some 1-2% on
-# runtime, enabling it makes not much sense:
+# This triggere link time optimization, which adds to compile time and gains (at most) a few 
+# percent on runtime. When set, because we're sparse, we also strip the binary.
 
 # set(LMT_OPTIMIZE 1)
 
@@ -29,6 +36,19 @@
 # anyway. 
 
 set(LMT_STRIP 1)
+
+# When one wants to use Lua libraries, this is needed. But keep in mind that it's not supported, 
+# so we won't look into issues that could result from that. Getting a matching library is upto 
+# the user. Keep in mind that we might have set a different bytecode (luac) version during the 
+# alpha/beta stages of a Lua development version. 
+
+# set(LMT_PERMIT_LUA_LIBRARIES 1)
+
+if (DEFINED LMT_PERMIT_LUA_LIBRARIES)
+    unset(LMT_STRIP)
+    unset(LMT_OPTIMIZE)
+    add_definitions(-DLMT_PERMIT_LUA_LIBRARIES="yes")
+endif ()
 
 if (MSVC)
 
@@ -82,7 +102,7 @@
 
           # /Ob3    # more agressive inline, much larger bin, no gain
 
-            /wd4061 # enumerator * in switch * is not explicitly handles (mp)
+            /wd4061 # enumerator * in switch * is not explicitly handled (mp)
             /wd4701 # potentially unitialized local variable (lua)
             /wd4255 # no function prototype given
 
@@ -193,6 +213,8 @@
         -Wno-unsafe-buffer-usage
         -Wno-macro-redefined
         -Wno-undef
+        -Wno-switch-default
+        -Wno-class-varargs
     )
 
 endif()
@@ -235,8 +257,15 @@
 #
 # When the old osx version is dropped and armhf is upgraded we can enable unix except solaris which
 # fails. So, only osx 10.6 and rpi 32 fail. But we will probably drop 32 bit in the future anyway.
+#
+# At the beginning of 2025 the gain is some 5 percent on the 650 page luametate manual over the 
+# default memory allocator. 
 
 # CMAKE_HOST_SYSTEM_PROCESSOR arm64 x86_64
+
+# if (APPLE)
+#     set(MI_OSX_ZONE 1)
+# endif()
 
 if (CMAKE_HOST_SOLARIS)
     # fails
@@ -246,6 +275,8 @@
     # fails on the osx intel
 elseif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "armv7l")
     # fails on the rpi 32 bit
+elseif (CMAKE_C_COMPILER_ID MATCHES "AppleClang|Clang")
+    # no motivation to figure specifics out
 else()
     set(luametatex_use_mimalloc 1)
 endif()

=== source/luacore/lua55/src/Makefile ===
--- 
+++ 
@@ -14,13 +14,12 @@
 	-Wdisabled-optimization \
 	-Wdouble-promotion \
 	-Wmissing-declarations \
+	-Wconversion \
+	-Wstrict-overflow=2 \
         # the next warnings might be useful sometimes,
 	# but usually they generate too much noise
 	# -Werror \
 	# -pedantic   # warns if we use jump tables \
-	# -Wconversion  \
-	# -Wsign-conversion \
-	# -Wstrict-overflow=2 \
 	# -Wformat=2 \
 	# -Wcast-qual \
 
@@ -63,16 +62,18 @@
 # ASAN_OPTIONS="detect_invalid_pointer_pairs=2".
 # -fsanitize=undefined
 # -fsanitize=pointer-subtract -fsanitize=address -fsanitize=pointer-compare
-# TESTS= -DLUA_USER_H='"ltests.h"' -O0 -g
+# TESTS= -DLUA_USER_H='"ltests.h"' -Og -g
 
 
 LOCAL = $(TESTS) $(CWARNS)
 
 
-# enable Linux goodies
-MYCFLAGS= $(LOCAL) -std=c99 -DLUA_USE_LINUX -DLUA_USE_READLINE
+# To enable Linux goodies, -DLUA_USE_LINUX
+# For C89, "-std=c89 -DLUA_USE_C89"
+# Note that Linux/Posix options are not compatible with C89
+MYCFLAGS= $(LOCAL) -std=c99 -DLUA_USE_LINUX
 MYLDFLAGS= $(LOCAL) -Wl,-E
-MYLIBS= -ldl -lreadline
+MYLIBS= -ldl
 
 
 CC= gcc
@@ -144,40 +145,46 @@
 lapi.o: lapi.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
  lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lstring.h \
  ltable.h lundump.h lvm.h
-lauxlib.o: lauxlib.c lprefix.h lua.h luaconf.h lauxlib.h
-lbaselib.o: lbaselib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+lauxlib.o: lauxlib.c lprefix.h lua.h luaconf.h lauxlib.h llimits.h
+lbaselib.o: lbaselib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 lcode.o: lcode.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
  llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
- ldo.h lgc.h lstring.h ltable.h lvm.h
-lcorolib.o: lcorolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+ ldo.h lgc.h lstring.h ltable.h lvm.h lopnames.h
+lcorolib.o: lcorolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 lctype.o: lctype.c lprefix.h lctype.h lua.h luaconf.h llimits.h
-ldblib.o: ldblib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+ldblib.o: ldblib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h llimits.h
 ldebug.o: ldebug.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
  lobject.h ltm.h lzio.h lmem.h lcode.h llex.h lopcodes.h lparser.h \
  ldebug.h ldo.h lfunc.h lstring.h lgc.h ltable.h lvm.h
 ldo.o: ldo.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
  lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lopcodes.h \
  lparser.h lstring.h ltable.h lundump.h lvm.h
-ldump.o: ldump.c lprefix.h lua.h luaconf.h lobject.h llimits.h lstate.h \
- ltm.h lzio.h lmem.h lundump.h
+ldump.o: ldump.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
+ lobject.h ltm.h lzio.h lmem.h lgc.h ltable.h lundump.h
 lfunc.o: lfunc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
  llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h
 lgc.o: lgc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
- llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lstring.h ltable.h
-linit.o: linit.c lprefix.h lua.h luaconf.h lualib.h lauxlib.h
-liolib.o: liolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+ llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h llex.h lstring.h \
+ ltable.h
+linit.o: linit.c lprefix.h lua.h luaconf.h lualib.h lauxlib.h llimits.h
+liolib.o: liolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h llimits.h
 llex.o: llex.c lprefix.h lua.h luaconf.h lctype.h llimits.h ldebug.h \
  lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lgc.h llex.h lparser.h \
  lstring.h ltable.h
-lmathlib.o: lmathlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+lmathlib.o: lmathlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 lmem.o: lmem.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
  llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h
-loadlib.o: loadlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+loadlib.o: loadlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 lobject.o: lobject.c lprefix.h lua.h luaconf.h lctype.h llimits.h \
  ldebug.h lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h \
  lvm.h
-lopcodes.o: lopcodes.c lprefix.h lopcodes.h llimits.h lua.h luaconf.h
-loslib.o: loslib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+lopcodes.o: lopcodes.c lprefix.h lopcodes.h llimits.h lua.h luaconf.h \
+ lobject.h
+loslib.o: loslib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h llimits.h
 lparser.o: lparser.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
  llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
  ldo.h lfunc.h lstring.h lgc.h ltable.h
@@ -186,25 +193,28 @@
  lstring.h ltable.h
 lstring.o: lstring.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
  lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h
-lstrlib.o: lstrlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+lstrlib.o: lstrlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 ltable.o: ltable.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
  llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
-ltablib.o: ltablib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+ltablib.o: ltablib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
 ltests.o: ltests.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
  lobject.h ltm.h lzio.h lmem.h lauxlib.h lcode.h llex.h lopcodes.h \
  lparser.h lctype.h ldebug.h ldo.h lfunc.h lopnames.h lstring.h lgc.h \
  ltable.h lualib.h
 ltm.o: ltm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
  llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
-lua.o: lua.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
+lua.o: lua.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h llimits.h
 lundump.o: lundump.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
  lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lstring.h lgc.h \
- lundump.h
-lutf8lib.o: lutf8lib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
-lvm.o: lvm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
- llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lopcodes.h lstring.h \
- ltable.h lvm.h ljumptab.h
-lzio.o: lzio.c lprefix.h lua.h luaconf.h llimits.h lmem.h lstate.h \
- lobject.h ltm.h lzio.h
+ ltable.h lundump.h
+lutf8lib.o: lutf8lib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h \
+ llimits.h
+lvm.o: lvm.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
+ lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lopcodes.h \
+ lstring.h ltable.h lvm.h ljumptab.h
+lzio.o: lzio.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
+ lobject.h ltm.h lzio.h lmem.h
 
 # (end of Makefile)

=== debian/changelog ===
luametatex (2.11.07+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Hilmar Preuße <hille42@debian.org>  Thu, 14 Aug 2025 22:35:41 +0200

luametatex (2.11.07+ds-1) experimental; urgency=medium

  * New upstream version, suitable for TL 2025.

 -- Hilmar Preuße <hille42@debian.org>  Tue, 01 Jul 2025 23:36:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: luametatex
 Section: tex
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
-Uploaders: Hilmar Preusse <hille42@web.de>
+Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
+Uploaders: Hilmar Preuße <hille42@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -16,6 +15,7 @@
 
 Package: luametatex
 Architecture: any
+Breaks: context (<< 2025)
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 
 # See FEATURE AREAS in dpkg-buildflags(1).
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # See ENVIRONMENT in dpkg-buildflags(1).
 # Package maintainers to append CFLAGS.

## luametatex 2.11.08%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,8 @@
 # I need to check with Mojca of the compile farm can handle this. 
 
 set(CMAKE_C_STANDARD 11)
-# set(CMAKE_C_STANDARD 17) # needs 3.21
+# set(CMAKE_C_STANDARD 17)
+# set(CMAKE_C_STANDARD 23)
 
 # https://sourceforge.net/p/predef/wiki/OperatingSystems/
 # https://sourceforge.net/p/predef/wiki/Architectures/
@@ -41,6 +42,11 @@
 # so we won't look into issues that could result from that. Getting a matching library is upto 
 # the user. Keep in mind that we might have set a different bytecode (luac) version during the 
 # alpha/beta stages of a Lua development version. 
+
+if (EXISTS "${CMAKE_SOURCE_DIR}/source/lua/lmthelperlib.c") 
+    set(luametatex_use_helpers 1)
+    add_definitions(-DLUAMETATEX_USE_HELPERS=1)
+endif()
 
 # set(LMT_PERMIT_LUA_LIBRARIES 1)
 
@@ -163,6 +169,11 @@
       # add_compile_options(-pg)
       # add_link_options(-pg)
 
+      # e.g. mp crashes when we have > 4K currentpicture clips in a row 
+
+    # set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,stack-size=1000000")
+      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,stack-size=2621440")
+
     endif()
 
     add_compile_options(
@@ -170,6 +181,12 @@
 
         -Wcast-align
         -Wcast-qual
+
+        # we need to check for zeros anyway as not all compiles have this 
+
+      # -fno-signed-zeros
+      # -fno-trapping-math
+      # -fno-math-errno
 
         -Wno-unknown-pragmas
         -Wno-unused-result
@@ -258,8 +275,8 @@
 # When the old osx version is dropped and armhf is upgraded we can enable unix except solaris which
 # fails. So, only osx 10.6 and rpi 32 fail. But we will probably drop 32 bit in the future anyway.
 #
-# At the beginning of 2025 the gain is some 5 percent on the 650 page luametate manual over the 
-# default memory allocator. 
+# At the beginning of 2025 on Windows 10 the gain is some 5 percent on the 650 page luametatex 
+# manual over the default memory allocator. 
 
 # CMAKE_HOST_SYSTEM_PROCESSOR arm64 x86_64
 
@@ -303,5 +320,7 @@
 include(cmake/miniz.cmake)
 include(cmake/softposit.cmake)
 include(cmake/potrace.cmake)
+include(cmake/qrcodegen.cmake)
+include(cmake/triangles.cmake)
 
 include(cmake/luametatex.cmake)
